"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _EchartsReactCore = _interopRequireDefault(require("../Core/EchartsReactCore"));

var _itemDefaultConfig = require("../../itemDefaultConfig");

var _Empty = _interopRequireDefault(require("../Empty"));

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var createTopRate = function createTopRate(data, isRate, i) {
  return "".concat(i === 0 ? data.name : '', "</br> ").concat(data.marker, " ").concat(data.seriesName, " :").concat(data.data).concat(isRate ? '%' : '');
};

var LineChart = /*#__PURE__*/(0, _react.forwardRef)(function (_ref, ref) {
  var _ref$config = _ref.config,
      title = _ref$config.title,
      legend = _ref$config.legend,
      grid = _ref$config.grid,
      xAxis = _ref$config.xAxis,
      yAxis = _ref$config.yAxis,
      series = _ref$config.series,
      otherConfig = _objectWithoutProperties(_ref$config, ["title", "legend", "grid", "xAxis", "yAxis", "series"]),
      showTitle = _ref.showTitle,
      rotate = _ref.rotate,
      showLabel = _ref.showLabel,
      interval = _ref.interval,
      dataZoom = _ref.dataZoom,
      isRate = _ref.isRate,
      rest = _objectWithoutProperties(_ref, ["config", "showTitle", "rotate", "showLabel", "interval", "dataZoom", "isRate"]);

  var isArray = Array.isArray;

  var option = _objectSpread({
    title: _objectSpread(_objectSpread({}, _itemDefaultConfig.titleTextStyle), {}, {
      show: showTitle
    }, title),
    tooltip: {
      trigger: 'axis',
      formatter: function formatter(data) {
        return data.map(function (data, i) {
          return createTopRate(data, isRate, i);
        }).join('');
      }
    },
    legend: _objectSpread(_objectSpread({
      top: showTitle ? 27 : 'top'
    }, _itemDefaultConfig.lbLegend), legend),
    grid: _objectSpread(_objectSpread({
      top: showTitle ? 66 : 36
    }, _itemDefaultConfig.lbGrid), grid),
    dataZoom: dataZoom ? _itemDefaultConfig.dataZoomConfig : [],
    xAxis: isArray(xAxis) ? xAxis.map(function (item) {
      return _objectSpread(_objectSpread({
        axisLabel: {
          interval: interval ? 'auto' : 0,
          rotate: rotate || 0
        }
      }, _itemDefaultConfig.lbXAxis), item);
    }) : _objectSpread(_objectSpread({
      axisLabel: {
        interval: interval ? 'auto' : 0,
        rotate: rotate || 0
      }
    }, _itemDefaultConfig.lbXAxis), xAxis),
    yAxis: isArray(yAxis) ? yAxis.map(function (item) {
      return _objectSpread(_objectSpread({
        axisLabel: {
          formatter: isRate ? '{value}%' : '{value}'
        }
      }, _itemDefaultConfig.lbYAxis), item);
    }) : _objectSpread(_objectSpread({
      axisLabel: {
        formatter: isRate ? '{value}%' : '{value}'
      }
    }, _itemDefaultConfig.lbYAxis), yAxis),
    series: series || []
  }, otherConfig);

  var targetArr = [];
  option.series.forEach(function (item) {
    if (showLabel || item.label && item.label.show) {
      item.label = _objectSpread(_objectSpread({}, _itemDefaultConfig.labelStyle), {}, {
        formatter: isRate ? '{c}%' : function (_ref2) {
          var value = _ref2.value;
          // 千分位分隔符
          return (0, _utils.formatNumber)(value);
        }
      }, item.label);
    }

    item.type = item.type || 'line';
    targetArr = targetArr.concat(item.data || []);
  });

  if (!targetArr.length) {
    return /*#__PURE__*/_react["default"].createElement(_Empty["default"], null);
  }

  return /*#__PURE__*/_react["default"].createElement(_EchartsReactCore["default"], _extends({
    notMerge: true,
    config: option,
    ref: ref
  }, rest));
});
LineChart.propTypes = {
  theme: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  interval: _propTypes["default"].bool,
  showTitle: _propTypes["default"].bool,
  showLabel: _propTypes["default"].bool,
  style: _propTypes["default"].object,
  className: _propTypes["default"].string,
  isRate: _propTypes["default"].bool,
  // 是否带百分比
  config: _propTypes["default"].shape({
    xAxis: _propTypes["default"].oneOfType([_propTypes["default"].array, _propTypes["default"].object]),
    yAxis: _propTypes["default"].oneOfType([_propTypes["default"].array, _propTypes["default"].object]),
    series: _propTypes["default"].array.isRequired
  }).isRequired,
  rotate: _propTypes["default"].number,
  dataZoom: _propTypes["default"].bool,
  // 是否开启x轴滚动，适合于x轴数据
  opts: _propTypes["default"].shape({
    devicePixelRatio: _propTypes["default"].number,
    renderer: _propTypes["default"].oneOf(['canvas', 'svg']),
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].oneOf([null, undefined, 'auto'])]),
    height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].oneOf([null, undefined, 'auto'])])
  })
};
LineChart.defaultProps = {
  style: {},
  classname: '',
  theme: 'macarons',
  rotate: 0,
  isRate: false,
  showTitle: false,
  interval: true,
  showLabel: false,
  dataZoom: false,
  config: {
    title: {},
    legend: {},
    toolbox: {},
    grid: {},
    xAxis: [{
      data: ['示意1', '示意2']
    }],
    yAxis: [_objectSpread({}, _itemDefaultConfig.lbYAxis)],
    series: [{
      data: [200, 600],
      type: 'line',
      name: '折线图'
    }]
  }
};
var _default = LineChart;
exports["default"] = _default;